<?php
#-------------------------------------------------------------------------
# Module: Newsletter Made Simple
#        (c) to 2008 by Paul Lempkepf
#        (c) 2008 and on by Robert Campbell (calguy1000@cmsmadesimple.org)
#
#  An addon module for CMS Made Simple to provide a flexible
#  mailing list solution.
#
#-------------------------------------------------------------------------
# CMSMS - CMS Made Simple is (c) 2005 by Ted Kulp (wishy@cmsmadesimple.org)
# Visit the CMSMS Homepage at: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE
if( !isset($gCms) ) exit;

try {
    if( !isset($params['uniqueid']) ) throw new CmsException('error_insufficientparams');
    $userinfo = nms_utils::get_userinfo(array('uniqueid'=>$params['uniqueid']));
    if( !isset($userinfo['userid']) || $userinfo['userid'] < 1 ) throw new CmsException($this->Lang('error_usernotfound'));

  $dateconfirmed = trim($db->DBTimeStamp(time()),"'");
  $userinfo['dateconfirmed'] = $dateconfirmed;
  $query = "UPDATE ".NMS_USERS_TABLE." SET confirmed = 1, dateconfirmed = ? WHERE uniqueid = ? AND email = ?";
  $dbresult = $db->Execute($query, array($dateconfirmed,$userinfo['uniqueid'],$userinfo['email']));

  $this->SendEvent('OnUserConfirmed', [ 'email' => $userinfo['email'], 'userid' => $userinfo['userid'], 'uniqueid' => $userinfo['uniqueid'] ] );
  $lists = $this->GetListsAsArray(array('status'=>'public','active'=>1,'dynamic'=>0));
  $smarty->assign('lists',$lists);
  $fielddefs = nms_fielddef::load_all();
  if( is_array($fielddefs) && count($fielddefs) ) $smarty->assign('fields',$fielddefs);

  $smarty->assign('userinfo',$userinfo);
  $smarty->assign('dateconfirmed',$userinfo['dateconfirmed']);
  $smarty->assign('uniqueid',$userinfo['uniqueid']);
  $smarty->assign('email', trim($userinfo['email']));
  $smarty->assign('username', trim($userinfo['username']));

  //send subscribe thank you e-mail.
  $mailer = new \cms_mailer;
  $mailer->SetSubject($this->GetPreference('confirm_subject'));

  $smarty->assign('unsubscribe',
                  $this->_cleanLink($this->CreateLink($id,'unsubscribe',$returnid,$this->Lang('unsubscribe'),
                                                      array('uniqueid' => $userinfo['uniqueid']))));
  $smarty->assign('unsubscribeurl',
                  $this->_cleanLink($this->create_url($id,'unsubscribe',$returnid,array('uniqueid' => $userinfo['uniqueid']), '', true)));
  $smarty->assign('preferences',
                  $this->_cleanLink($this->CreateLink($id,'usersettings',$returnid,$this->Lang('preferences'),
                                                      array('uniqueid' => $userinfo['uniqueid']))));
  $smarty->assign('preferencesurl',
                  $this->_cleanLink($this->create_url($id,'usersettings',$returnid,array('uniqueid' => $userinfo['uniqueid']), '', true)));

  $bodyText = $this->ProcessTemplateFromDatabase('confirm_email_body');
  $mailer->IsHTML($this->GetPreference('confirm_email_html',0));
  $mailer->SetBody($bodyText);
  $mailer->AddAddress($userinfo['email']);
  $mailer->SetCharSet($this->GetPreference('message_charset'));
  $mailer->SetFromName($this->GetPreference('admin_name'));
  $mailer->SetFrom($this->GetPreference('admin_email'));
  if( !$mailer->Send() ) {
    audit('',$this->GetName(),'Problem sending email to '.$userinfo['email']);
    nms_utils::user_adderror($userinfo['userid']);
    throw new CmsException($this->Lang('error_send',$userinfo['email'],$mailer->GetErrorInfo()));
  }
}
catch( Exception $e ) {
  $smarty->assign('error',1);
  $smarty->assign('message',$e->GetMessage());
}

echo $this->ProcessTemplateFromDatabase('post_email_confirm_message');

?>